#!/usr/bin/perl
use warnings;
# ezTree_sub.pl $tmpdir $f $EVALUE_CUTOFF $PFAMDB $HMMSCAN

$CPU = 2;

if (-e "$ARGV[0]/$ARGV[1].hmm")
{
	# Do nothing
}
elsif (-e "$ARGV[0]/$ARGV[1].faa" && ((-s "$ARGV[0]/$ARGV[1].faa") > 0))
{
	open(FILE, "<$ARGV[0]/$ARGV[1].faa");
	open(OUT, ">$ARGV[0]/$ARGV[1].tmp");
	$i = 1;
	while(defined($line = <FILE>))
	{
		chomp($line);
		if ($line =~ /^>/)
		{
			print OUT ">$ARGV[1].$i\n";
			$i++;
		}
		elsif ($line ne "")
		{
			print OUT "$line\n";
		}
	}
	close(FILE);
	close(OUT);

	# Run hmmscan
	print "Running hmmscan on $ARGV[1]\n";
	$cmd = "$ARGV[4] -o $ARGV[0]/$ARGV[1].tmp2 --tblout $ARGV[0]/$ARGV[1].hmm --cpu $CPU -E $ARGV[2] $ARGV[3] $ARGV[0]/$ARGV[1].tmp";
	system($cmd);
	unlink("$ARGV[0]/$ARGV[1].faa");
	rename("$ARGV[0]/$ARGV[1].tmp", "$ARGV[0]/$ARGV[1].faa");
	unlink("$ARGV[0]/$ARGV[1].tmp2");
}
else
{
	print "Error predicting genes from $ARGV[1]\n";
	$err = 1;
}
if ($err != 0)
{
    print "Error occurred. Program stop.\n";
    exit;
}

